;------------------------------------------------------------
; LCD.S (written by BLUE 2003-04-22)
; Display lcd routine. (LCDTP area data --> LCD)
; ( Compatible DOTDS routine for PB-1000/C/AI-1000/FX-870P)
; LCD\GARAMLCDhCoIC֓]B
; iROM[`DOTDSƓ܂j
;------------------------------------------------------------
; This is public domain program.
;------------------------------------------------------------
; [ASSEMBLE THIS FILE]
;   >HD61 lcd.s /p [enter]
; Transmit lcd.pbf --> PB-1000/AI-1000/FX-870P
;
;------------------------------------------------------------
; LCD Control protcol
;------------------------------------------------------------
; References :
; [Pockecom Journal] 1993/12 [DOTDS] by N.Hayashi
; LCD@́A|PRW[i1993/12ɍČfڂꂽ
; N.Hayashi(͂)̋LɂĂ܂B
;------------------------------------------------------------
; The LCD control is possible that it does it with the next method.
; LCD́Aȉ̎菇ōsƂ\łB
; (1) Select LCD register or data ram.(use PPO operation.)
;     PPO߂ɂāALCD䃌WX^f[^RAMwB
; (2) Set control or display data to LCD.(use STL* operation.)
;     STL߂ɂāAۂ̃f[^݂܂B
;
; [lcd control register (8bit:write only)]
;   Bit<7> ------- LCD VDD (1:ON,0:OFF)
;   Bit<6> ------- LCD CLOCK (0:STOP)
;   Bit<5> ------- NOT USED
;   Bit<4>-<1> --- REGISTER NUMBER?:NEGATIVE LOGIC(ALL 1)
;   Bit<0> ------- OP(1:command register ,0:data ram)
;
; for example:
;  PPO &HDF          ;select command register(R}hWX^w)
;  PPO &HDE          ;select data ram(f[^RAMw)
;
; It is possible to do the setting of LCD with a STL operation,
; after command register is selected.
; R}hWX^wASTL߂ɂLCD̓샂[hAAhX
; ݒ\łBݒ肷Ƃ͈ȉ̏ŏo͂܂B
;
; [lcd command format]
;  [Mode],[Addres(columns)],[Address(line)]
;
; [Mode ( 8bit )]
;  Bit<7>-<5> --- IMAGE MODE ( 000:nand? , 001:XOR , 100:Normal, 101:OR )
;  Bit<4> ------- LCD SELECT ( 0:LCD1 , 1:LCD2 )
;  Bit<3>-<0> --- Mode(4:unknown(CONTRAST?),3:CHRACTER,2:BIT IMAGE,0:unknown)
;
; [Address ( 8bit * 2 )]
;   LCD ADDRESS(columns)
;   (1)Bit image mode          --- (0,2,4,..,188,190)
;   (2)Character mode (0 - 5)  --- (0,16,32,48,64,72)
;                     (6 - 11) --- (128,144,160,176,192,208)
;   LCD ADDRESS(line)    --- (0,1,2,3)
;
; f[^݃[h́ASTL߂ɂďo͂ꂽf[^A
; ݒ肳ꂽLCDAhXo͂܂BiLQƁj
;
; for example:
;(1)display bitimage '&HAA' (rbgC[W&hAALCDɏo)
;  PPO   &HDF         ;Select command register
;  LD    $0,&H82      ;Set bitimage mode & LCD1 select
;  LD    $1,8         ;Set LCD address(columns=(8/2)=4)
;  LD    $2,0         ;Set LCD address(line=0)
;  STLM  $0,3         ;Set LCD command register & address(3byte)
;  LD    $3,&HAA      ;Set data '&HAA'
;  PPO   &HDE         ;Select data ram
;  STL   $3           ;Display LCD( 8bit data )
;  RTN
;
;(2)display character "A" (LN^"A"LCDɏo)
;  PPO   &HDF         ;Select command register
;  LD    $0,&H83      ;Set character mode & LCD1 select
;  LD    $1,48        ;Set LCD address(columns=(48/16)=3)
;  LD    $2,0         ;Set LCD address(line=0)
;  STLM  $0,3         ;Set LCD command register & address(3byte)
;  LD    $3,&H14      ;Set data "A" ("A"=&H41 --> &H14)
;                                   ("2"=&H32 --> &H23)
;  PPO   &HDE         ;Select data ram
;  STL   $3           ;Display LCD( character data )
;  RTN
;------------------------------------------------------------

;------------------------------------------------------------
; MODEL NUMBER
;------------------------------------------------------------
PB1000:    EQU     1                   ;PB-1000/C
AI1000:    EQU     2                   ;AI-1000
FX870P:    EQU     3                   ;FX-870P/VX-4
;------------------------------------------------------------
MODEL:     EQU     PB1000              ;Select your machine.

;------------------------------------------------------------
; System work define.
;------------------------------------------------------------
#if (MODEL=PB1000)
LCDTP:     EQU     &H6201              ;LCDTP Address
BASE:      EQU     &H7000              ;Program start address
#endif
#if (MODEL=AI1000)
LCDTP:     EQU     &H0201              ;LCDTP Address
BASE:      EQU     &H1000              ;Program start address
#endif
#if (MODEL=FX870P)
LCDTP:     EQU     &H123C              ;LCDTP Address
BASE:      EQU     &H100               ;Program start address
#endif

;------------------------------------------------------------
; DISPLCD
; ( compatible DOTDS routine for PB-1000/C/AI-1000/FX-870P)
; INPUT : none
; USE REGISTER : $0 - $9 , IX
;------------------------------------------------------------
           START   DISPLCD
           ORG     BASE                ;
DISPLCD:
           PPO     &HDF                ;Set LCD (Select command register)
           LDW     $0,&H82             ;Set Bitimage mode(OR:&HA2,XOR:&H22)
           XR      $2,$2               ;Set LCD Address = 0,0
           STLM    $0,3                ;(write lcd register)

           PRE     IX,LCDTP            ;IX = LCDTP
           LD      $8,4                ;Set LCD line( = 4 )
LOOP:
           PPO     &HDF                ;Set LCD (Select command register)
           STL     &H82                ;select LCD1(left part of lcd)

           CAL     DISPL               ;LCDTP --> LCD( 96 byte )

           PPO     &HDF                ;Set LCD (Select command register)
           STL     &H92                ;select LCD2(right part of lcd)

           CAL     DISPL               ;LCDTP --> LCD( 96 byte )

           SB      $8,$30              ;finished ?
           JR      NZ,LOOP             ;

#if (MODEL=FX870P)
;           PST     UA,&H54             ;return BASIC
#endif
           RTN                         ;

;----------------------------------
; INPUT : IZ -- LCDTP pointer
;----------------------------------
DISPL:
           PPO     &HDE                ;Set LCD (Select data ram)
           LD      $9,12               ;Set half line ( 12*8 = 96byte )
DLCDL:
           LDIM    $0,(IX+$31),8       ;Read bit data ( 8byte )
           STLM    $0,8                ;Display LCD ( 8byte )

           SB      $9,$30              ;finished ?
           JR      NZ,DLCDL            ;
           RTN
